#!/usr/bin/env python

"""
A variable-length integer encoding implementation in Pyrex.

Copyright (C) 2009 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

cdef extern from "Python.h":
    object PyString_FromStringAndSize(char *, int)

def vint(int number):

    cdef char bytes[40] # NOTE: Arbitrary limit.
    cdef int lsd, i

    if number < 128:
        bytes[0] = number
        s = PyString_FromStringAndSize(bytes, 1)
        return s

    i = 0
    while number != 0:
        lsd = number & 127
        number = number >> 7
        if number != 0:
            lsd = lsd | 128
        bytes[i] = lsd
        i = i + 1

    s = PyString_FromStringAndSize(bytes, i)
    return s

# vim: tabstop=4 expandtab shiftwidth=4
